<?php

namespace FiloBlu\Refilo\Model\Redirects;

use FiloBlu\Refilo\Model\Redirects\Interfaces\RedirectInterface;
use Magento\Framework\Model\AbstractModel;

class Redirects implements RedirectInterface
{
    const CACHE_TAG = 'filoblu_refilo_redirects';

    protected $_cacheTag = 'filoblu_refilo_redirects';

    protected $_eventPrefix = 'filoblu_refilo_redirects';
    /**
     * @var string
     */
    public $host;
    /**
     * @var string
     */
    public $request_url;
    /**
     * @var string
     */
    public $target_url;
    /**
     * @var int
     */
    public $redirect_code;
    protected $id;

    public function getIdentities()
    {
        return [self::CACHE_TAG . '_' . $this->getId()];
    }

    public function setHost(string $host) : RedirectInterface
    {
        $this->host = $host;
        return $this;
    }

    public function setRequestUrl(string $requestUrl) : RedirectInterface
    {
        $this->request_url = $requestUrl;
        return $this;
    }

    public function setTargetUrl(string $targetUrl) : RedirectInterface
    {
        $this->target_url = $targetUrl;
        return $this;
    }

    public function setRedirectCode(string $redirectCode) : RedirectInterface
    {
        $this->redirect_code = (int)$redirectCode;
        return $this;
    }

    public function getHost()
    {
        return $this->host;
    }

    public function getRequestUrl()
    {
        return $this->request_url;
    }

    public function getTargetUrl()
    {
        return $this->target_url;
    }

    public function getRedirectCode()
    {
        return $this->redirect_code;
    }

    public function getId()
    {
        return $this->id;
    }

    public function setId($id): RedirectInterface
    {
        $this->id = $id;
        return $this;
    }
}
